package net.sourceforge.basher.example.tasks.hivemind;

import java.util.concurrent.locks.Lock;
import java.util.concurrent.locks.ReentrantLock;

import org.apache.hivemind.ApplicationRuntimeException;
import org.apache.hivemind.Registry;
import org.apache.hivemind.impl.RegistryBuilder;
import org.ops4j.gaderian.Location;
import org.ops4j.gaderian.internal.Module;
import org.ops4j.gaderian.service.ObjectProvider;


/**
 * @author Johan Lindquist
 */
public class SampleHivemindObjectProvider implements ObjectProvider
{
    private Registry _registry;
    private Lock _lock = new ReentrantLock( );

    public Object provideObject( final Module module, final Class aClass, final String s, final Location location )
    {
        try
        {
            _lock.lock();
            try
            {
                if (_registry == null)
                {
                    _registry = RegistryBuilder.constructDefaultRegistry();
                }
            }
            finally
            {
                _lock.unlock();
            }

            return _registry.getService( s,aClass );
        }
        catch ( ApplicationRuntimeException e )
        {
            throw new org.ops4j.gaderian.ApplicationRuntimeException(e.getMessage(), e);
        }

    }
}