package net.sourceforge.basher.example.tasks.spring;

import org.ops4j.gaderian.ApplicationRuntimeException;
import org.ops4j.gaderian.Location;
import org.ops4j.gaderian.internal.Module;
import org.ops4j.gaderian.service.ObjectProvider;
import org.springframework.beans.BeansException;
import org.springframework.beans.factory.BeanFactory;
import org.springframework.beans.factory.NoSuchBeanDefinitionException;
import org.springframework.beans.factory.xml.XmlBeanFactory;
import org.springframework.core.io.ClassPathResource;

/**
 * @author Johan Lindquist
 */
public class SampleSpringBeanFactory implements BeanFactory
{
    private BeanFactory _beanFactory;

    public void initializeService()
    {
        _beanFactory = new XmlBeanFactory( new ClassPathResource( "basher-spring-beans.xml") );
    }

    public Object getBean( final String s ) throws BeansException
    {
        return _beanFactory.getBean( s );
    }

    public <T> T getBean( final String s, final Class<T> tClass ) throws BeansException
    {
        return _beanFactory.getBean( s, tClass );
    }

    public <T> T getBean( final Class<T> tClass ) throws BeansException
    {
        return _beanFactory.getBean( tClass );
    }

    public Object getBean( final String s, final Object... objects ) throws BeansException
    {
        return _beanFactory.getBean( s, objects );
    }

    public boolean containsBean( final String s )
    {
        return _beanFactory.containsBean( s );
    }

    public boolean isSingleton( final String s ) throws NoSuchBeanDefinitionException
    {
        return _beanFactory.isSingleton( s );
    }

    public boolean isPrototype( final String s ) throws NoSuchBeanDefinitionException
    {
        return _beanFactory.isPrototype( s );
    }

    public boolean isTypeMatch( final String s, final Class aClass ) throws NoSuchBeanDefinitionException
    {
        return _beanFactory.isTypeMatch( s, aClass );
    }

    public Class<?> getType( final String s ) throws NoSuchBeanDefinitionException
    {
        return _beanFactory.getType( s );
    }

    public String[] getAliases( final String s )
    {
        return _beanFactory.getAliases( s );
    }
}
